/**
 * FiocruzDTB PPU Player API
 * 
 * A tool used to connect to resources created with the Pacote Padrão UNASUS - PPU standard and 
 * to Moodle and other LMSs trough the LTI standard.
 *
 * The primary goal of the FiocruzDTB PPU Player is to act as the Provider in the LTI architecture, reading a 
 * module's information from the PPU package and returning the user status to the Consumer via the 
 * LTI pattern.
 *
 * The secondary goal of this player is to store and retrieve information generated by the PPU package, 
 * in order to make the PPU resistant to any sort of loss of information on the users' browser's local 
 * storage.
 *
 * The third goal of this player is to allow the analysis of a user's data and it's progress on the 
 * educational resource offered by the PPU package, via report functions generated based on the 
 * information gathered from the PPU.
 * 
 * @author: Diego M. Silva - diegomsilva.com
 * @version: v1.0.2 - Integrated changes made by the Fiocruz deployment team and updated project title on HTML headers.
 * @updated-at: 03/07/2019
 * 
 * References:
 * https://www.imsglobal.org/activity/learning-tools-interoperability
 * https://github.com/IMSGlobal/LTI-Tool-Provider-Library-PHP
 * https://www.npmjs.com/package/ims-lti
 */

/**
 * Dependencies
 */
// External
const express = require("express");
const bodyParser = require("body-parser");
const nosqlManager = require("./persistence/nosql_manager");
const { check } = require("express-validator/check");

// Local
const publicSettings = require("./settings/public");
const PPULTIController = require("./controllers/ppu_lti_controller");

/**
 * Server configuration
 */
const APP_NAME = "FiocruzDTB PPU Player API, v1.0.0";

const app = express();

// Basic setup
app.set('port', (process.env.PORT || 5000));
app.set('public', __dirname + '/');
app.use(express.static(__dirname + '/public'));
app.use(bodyParser.urlencoded({ extended: false }));
app.post("*", bodyParser.urlencoded({ extended: true }));

// The option below allows an http connection between the Consumer and the Provider, however the user 
// data is visible by anyone, therefore, the ideal is to have https both on the Consumer and the Provider 
// ends and then disable the setting below.
app.enable('trust proxy');

/**
 * Endpoints
 */
app.get('/about', function(req, res) {
   res.send(APP_NAME);
});
app.get('/', function (req, res) {
   PPULTIController.displayPPU(req, res);
});
app.post('/ext_module', function (req, res) {
   PPULTIController.initializeExternalLTIModule(req, res);
});
app.get("/ext_module/API/GetUser/:userUID/:ppuid", [
   check('userUID').isEmail().escape(),
   check('ppuid').isString().escape()
], (req, res) => {
   PPULTIController.getUser(req, res);
});
app.post("/ext_module/API/GetData/:userUID/:ppuid", [
   check('userUID').isEmail().escape(),
   check('ppuid').isString().escape(),
   check('Storage').isJSON()
], (req, res) => {
   PPULTIController.getData(req, res);
});
app.post("/ext_module/API/SetData/:userUID/:ppuid/:sessionid", [
   check('userUID').isEmail().escape(),
   check('ppuid').isString().escape(),
   check('Storage').isJSON()
], (req, res) => {
   PPULTIController.setData(req, res);
});

/**
 * Server initialization
 */
app.listen(app.get('port'), function () {
   console.log(`${APP_NAME} - is running on port ${app.get('port')}`);

   publicSettings.register_logs_remote_db = true;
   nosqlManager.connectToFrbDB();
});